<template>
  <div class="expert-calendar" v-if="!!seasonWeeks">
    <div
      class="expert-calendar__cell"
      v-for="(item, index) in items"
      :class="[item.seasonClass, {
        'selected-cell': item.hasTooltip
      }]"
      :key="item.id"
      @click="handleCellFocus(index, $event)"
      @keydown.tab="handleCellTab(index, $event)"
      v-click-outside="handleClickOutside(index)"
    >
      <span class="index">{{ item.index }}</span>

      <ob-input
        v-if="selectedCell === index"
        type="number:2"
        :value="inputValue"
        @input="rateChange"
        class="value-input"
        @on-enter="cellBlur(index)"
        :key="index"
      />
      <span class="value" v-else>{{ (""+seasonWeeks[index]).replace('.', ',') }}</span>

      <template v-if="item.hasTooltip">
        <ob-tooltip position="top" :content="item.tooltipText">
          <div class="flag"></div>
        </ob-tooltip>
      </template>
    </div>
  </div>
</template>

<script>
import ObTooltip from 'common-components/src/obComponents/obTooltip';
import ObInput from 'common-components/src/obComponents/obInput';
import ClickOutside from 'vue-click-outside';
import { mapGetters, mapActions } from 'vuex';

import calendarData from './calendarData';

export default {
  name: 'calendar-seasons',
  directives: {
    ClickOutside,
  },
  components: {
    ObTooltip,
    ObInput,
  },
  inheritAttrs: false,
  computed: {
    ...mapGetters({
      seasonWeeks: 'base_prices/mathModelWeeks',
    }),
    inputValue() {
      return ('' + this.currentCellValue || '').replace('.', ',');
    },
  },
  data() {
    this.items = calendarData;
    return {
      currentCellValue: '',
      selectedCell: null,
    };
  },
  methods: {
    ...mapActions({
      setCellValue: 'base_prices/setExpertWeekRateByIndex',
    }),
    noop() {},
    rateChange(value) {
      this.currentCellValue = value;
    },
    handleNewInput(inputParent) {
      this.$nextTick(() => {
        //without nextTick selector will not work
        const inputEl = inputParent.querySelector('input');
        this.input = inputEl;

        this.input.focus();
        this.attachEscHandler();
      });
    },
    selectCell(idx, inputParent) {
      this.selectedCell = idx;

      this.currentCellValue = this.seasonWeeks[idx];
      this.handleNewInput(inputParent);
    },
    validateAndAssignValue(index) {
      //returning value to js number format
      const newValue = +this.currentCellValue.replace(',', '.');

      if (!Number.isNaN(newValue) && newValue > 0) {
        this.setCellValue({ index, value: newValue });
      }

      this.currentCellValue = '';
    },
    cellBlur(index, force) {
      if (!force && (!this.selectedCell || index !== this.selectedCell)) {
        return;
      }

      if (!force) {
        this.validateAndAssignValue(index);
      }

      this.detachEscHandler();

      this.input = null;
      this.selectedCell = null;
    },
    resetChange(evt) {
      if (evt.keyCode === 27) {
        evt.stopPropagation();

        this.cellBlur(undefined, true);
      }
    },
    attachEscHandler() {
      if (this.input) {
        this.input.addEventListener('keydown', this.resetChange, true);
      }
    },
    detachEscHandler() {
      if (this.input) {
        this.input.removeEventListener('keydown', this.resetChange, true);
      }
    },
    handleClickOutside(index) {
      return index === this.selectedCell
        ? () => this.cellBlur(index)
        : this.noop;
    },
    handleCellFocus(index, evt) {
      if (index === 0) {
        return;
      }

      if (!this.selectedCell || this.selectedCell !== index) {
        if (this.selectedCell) {
          this.cellBlur(this.selectedCell);
        }

        const el = evt.currentTarget;

        this.selectCell(index, el);
      }
    },
    handleCellTab(evtIndex, evt) {
      evt.preventDefault();
      // @todo to switch to next cell
      return this.cellBlur(evtIndex);
    },
  },
};
</script>

<style lang="scss" scoped>
$cobalt-black: #191e32;
$shale-gray: #474b5b;
$gray-slate: #737682;

@import '../../../../../../node_modules/common-components/src/static/css/mixins';

.expert-calendar {
  display: flex;
  width: 578px;
  flex-wrap: wrap;
  margin: 0 auto;
  &__cell {
    width: 72px;
    height: 62px;
    border: 1px solid rgba(25, 30, 50, 0.05);
    position: relative;
    display: flex;
    flex-wrap: wrap;
    padding: 10px 12px;
    &.selected-cell {
      overflow: hidden;
      .flag {
        display: block;
        width: 10px;
        height: 10px;
        position: absolute;
        top: -10px;
        right: -10px;
        border-bottom: 10px solid #e62d3b;
        border-left: 10px solid transparent;
        border-top: 10px solid transparent;
        border-right: 10px solid transparent;
        transform: rotate(45deg);
      }
    }
    .value {
      pointer-events: none;
      width: 100%;
      text-align: left;
      @include font-mixin(16px, 20px, 400, $cobalt-black, 0.2px);
    }
    .value-input::v-deep .ob-input-wrap {
      height: 30px;
      padding: 4px 7px;

      input {
        font-size: 14px;
      }
    }
    .index {
      width: 100%;
      text-align: right;
      @include font-mixin(12px, 17px, 400, #9da0ac, 0.2px);
    }
  }
  .__winter {
    background: #e5edf9;
    &.__spring {
      background: linear-gradient(90deg, #e5edf9 7.53%, #fffbda 100%);
    }
  }
  .__spring {
    background: #fffcdb;
    &.__summer {
      background: linear-gradient(90deg, #fffbda 0.68%, #b7f1e0 100%);
    }
  }
  .__summer {
    background: #b7f1e0;
    &.__autumn {
      background: linear-gradient(90deg, #b7f1e0 0%, #ffefd7 100%);
    }
  }
  .__autumn {
    background: #ffefd7;
    &.__winter {
      background: linear-gradient(90deg, #ffefd7 0%, #e5edf9 100%);
    }
  }
}
</style>
